package insurance;

import insurance.helper.ProcessingContext;

import com.metamaxim.modelscope.callbacks.Behaviour;
import com.metamaxim.modelscope.callbacks.Instance;

import java.security.acl.Owner;
/**
 * Evaluate age of member
 */
public class AgeCondition extends Behaviour{
    public String getState() {
        Instance currentClaim=ProcessingContext.getCurrentClaim();
        if (currentClaim == null) {
            return "Within Limit";
        }
        Instance person = currentClaim.getInstance("Policy").getInstance("Person");
        int age=person.getInteger("Age");
        
        Instance policyCoverage = this.getInstance("Coverage");
        
        int minimum = policyCoverage.getInteger("Age From");
        int maximum = policyCoverage.getInteger("Age To");
        
        return (age >= minimum && age <= maximum) ? "Within Limit" : "Outside Limit";
    }
}
