package insurance;

import com.metamaxim.modelscope.callbacks.Event;
import com.metamaxim.modelscope.callbacks.Instance;
/**
 * Pays after deduction of copayment.
 */
public class CalculateBenefitCoPayment extends Event {
    public void handleEvent() {
        this.log("Processing of ");
        Instance claim = this.getInstance("Claim");
        Instance benefit = this.getInstance("BenefitCoPayment");
        //Gegevens per eenheid
        Instance policyCoverage = benefit.getInstance("Coverage");
        int coPayment = policyCoverage.getCurrency("CoPayment Amount");
        int price = claim.getInstance("CareProcedure").getCurrency("Price");
        int number = claim.getInteger("Number");

        int totalAmount = number * (price - coPayment);
        int benefitAmount = totalAmount;

        if (benefitAmount != 0) {
            Event grantBenefitEvent = this.createEvent("Grant Benefit");
            grantBenefitEvent.setInstance("Claim", claim);
            grantBenefitEvent.setCurrency("Benefit Amount", benefitAmount);
            grantBenefitEvent.log("Created ");
            grantBenefitEvent.submitToModel();
        }

        //houd evt eigen bijdrage in
        int totalCoPaymentAmount = number * coPayment;

        if (totalCoPaymentAmount != 0) {
            Event coPaymentEvent = this.createEvent("Deduct CoPayment");
            coPaymentEvent.setInstance("Claim", claim);
            coPaymentEvent.setCurrency("CoPayment Amount", totalCoPaymentAmount);
            coPaymentEvent.log("Created ");
            coPaymentEvent.submitToModel();
        }
    }
}
