package insurance;

import com.metamaxim.modelscope.callbacks.Event;
import com.metamaxim.modelscope.callbacks.Instance;

/**
 * Calculates benefits as percentage of price.
 */
public class CalculateBenefitPercentage extends Event{
    public void handleEvent() {
        this.log("Processing of ");
        Instance claim = this.getInstance("Claim");
        Instance benefitCalculator = this.getInstance("BenefitPercentage");
        Instance policyCoverage = benefitCalculator.getInstance("Coverage");
        int percentage = policyCoverage.getInteger("Percentage");
        int number = claim.getInteger("Number");
        
        int amount = number * percentage*claim.getInstance("CareProcedure").getCurrency("Price")/100;
//        int reedsBetaald = claim.getCurrency("Benefit Amount");
//        int teBetalen = (amount - reedsBetaald);
        if (amount != 0) {
            Event grantBenefitEvent = this.createEvent("Grant Benefit");
            grantBenefitEvent.setInstance("Benefit", claim);
            grantBenefitEvent.setCurrency("Benefit Amount", amount);
            grantBenefitEvent.log("Created ");
            grantBenefitEvent.submitToModel();
        }
    }
}
