package insurance;

import com.metamaxim.modelscope.callbacks.Event;
import com.metamaxim.modelscope.callbacks.Instance;

/**
 * Calculates the price of the claim using the careprocedure price (fixed price)
 */
public class CalculateFixedPrice extends Event {
    public void handleEvent() {
        this.log("Processing of ");
        Instance claim = this.getInstance("Claim");

        int price =
            claim.getInstance("CareProcedure").getCurrency("Price");

        Event enterPriceEvent = this.createEvent("Enter Price");
        enterPriceEvent.setInstance("Claim", claim);
        enterPriceEvent.setCurrency("Price", price);
        enterPriceEvent.log("Created ");
        enterPriceEvent.submitToModel();
    }
}
