package insurance;

import insurance.helper.ProcessingContext;

import com.metamaxim.modelscope.callbacks.Behaviour;
import com.metamaxim.modelscope.callbacks.Instance;

/**
 * Vergoed op basis van de zorgprocedure van de claim.
 */
public class CareProcedureCondition extends Behaviour {
    public String getState() {
        Instance claim = ProcessingContext.getCurrentClaim();
        if (claim == null) {
            return "Not Covered";
        }

        String procedureCode =
            claim.getInstance("CareProcedure").getString("Code");
        //Get related coverage
        Instance coverage = this.getInstance("Coverage");

        Instance[] members =
            coverage.selectByRef("CareProcedureGroupMember", "CareProcedureGroup");
        //Loop over all members of the group
        for (Instance member : members) {
            if ("Active".equals(member.getState())) {
                String memberProcedureCode =
                    member.getInstance("CareProcedure").getString("Code");

                if (procedureCode.equals(memberProcedureCode)) {
                    return "Covered";
                }
            }
        }
        return "Not Covered";
    }
}
