package insurance;


import com.metamaxim.modelscope.callbacks.Event;
import com.metamaxim.modelscope.callbacks.Instance;


/**
 */
public class CreatePolicy extends Event {

    public void handleEvent() {
        this.submitToModel();
        Instance product = this.getInstance("Product");
        Instance policy=this.getInstance("Policy");
        
        Instance[] coverages = product.selectByRef("Coverage", "Product");
        
        for (Instance coverage: coverages) {
                //Generate a create policy coverage event
                String objectType = coverage.getObjectType();
                Event event = this.createEvent("Create PolicyCoverage");
                event.setNewInstance("PolicyCoverage","Policy" + objectType);
                event.setInstance("Coverage", coverage);
                event.setInstance("Policy", policy);
                event.submitToModel();
        }
    }
}
