package insurance;

import com.metamaxim.modelscope.callbacks.Event;
import com.metamaxim.modelscope.callbacks.Instance;

public class ProcessClaim extends Event{
/**
 * Processes the claim
 */
    public void handleEvent() {
        this.log("Processing of ");
        Instance coverage = this.getInstance("PolicyCoverage");
        Instance claim = this.getInstance("Claim");

        Event setPolicyCoverage = this.createEvent("Assign PolicyCoverage");
        setPolicyCoverage.setInstance("Claim", claim);
        setPolicyCoverage.setInstance("PolicyCoverage", coverage);
        setPolicyCoverage.submitToModel();

        //Ech policycoverage can have a different behaviour for pricecalculation.
        String priceCalculatorName = coverage.getString("PriceCalculatorName");
        Event calculatePriceEvent = this.createEvent("Calculate " + priceCalculatorName);
        calculatePriceEvent.setInstance("Claim", claim);
        calculatePriceEvent.setInstance(priceCalculatorName, coverage);
        calculatePriceEvent.submitToCallback();

        //Idem for benefits calculation
        String benefitName = coverage.getString("BenefitName");
        Event calculateBenefit = this.createEvent("Calculate " + benefitName);
        calculateBenefit.setInstance("Claim", claim);
        calculateBenefit.setInstance(benefitName, coverage);
        calculateBenefit.submitToCallback();

        //Send Processing compleet
        Event processingCompleteEvent = this.createEvent("Complete Processing");
        processingCompleteEvent.setInstance("Claim", claim);
        processingCompleteEvent.setString("Processing Info", "Completed");
        processingCompleteEvent.submitToModel();

    }
}
