package insurance;


import insurance.helper.ProcessingContext;

import com.metamaxim.modelscope.callbacks.Behaviour;
import com.metamaxim.modelscope.callbacks.Instance;

/**
 * Conditie die alleen claims accepteert met de juiste behandeling.
 * Voorbeeld: voor IVF worden alleen behandeling 2 en 3 vergoed.
 */
public class TreatmentCondition extends Behaviour {
    public String getState() {
        Instance currentClaim = ProcessingContext.getCurrentClaim();
        if (currentClaim == null) {
            return "buiten grens";
        }
        int behandeling = currentClaim.getInteger("Behandeling");

        Instance coverage = this.getInstance("Coverage");
        int vanafBehandeling = coverage.getInteger("Vanaf Behandeling");
        int tmBehandeling = coverage.getInteger("Tm Behandeling");

        if (vanafBehandeling != 0) {
            if (behandeling < vanafBehandeling) {
                return "buiten grens";
            }
        }

        if (tmBehandeling != 0) {
            if (behandeling > tmBehandeling) {
                return "buiten grens";
            }
        }
        return "in grens";
    }
}
